#define _CRT_SECURE_NO_WARNINGS

#include "q5_t_polygone.h"

//Alloue dynamiquement un polygone au nombre de points dsir
t_polygone* init_polygone(int nb_points)
{
	t_polygone *poly;

	//Allocation du polygone
	poly = (t_polygone*)malloc(sizeof(t_polygone));
	if (poly == NULL) {
		return NULL;
	}

	//Initialisation de la valeur du nombre de points
	poly->nb_points = nb_points;

	//Le polygone contient un tabeau dynamique de t_point. Il faut l'allouer au nombre 
	//de points reu en paramtres.
	poly->points = (t_point*)malloc(nb_points * sizeof(t_point));
	if (poly->points == NULL) { 
		free(poly); //Si erreur d'allocation des points, c'est une erreur gnrale et on libre
					//ce qu'on a prcdemment allou.
		return NULL;
	}

	return poly;
}

//Dtruit un polygone qui a t allou dynamiquement
void detruire_polygone(t_polygone* poly)
{
	if (poly != NULL) { //On s'assure que poy n'est pas NULL (sinon impossible d'accder au champs points)
		free(poly->points); //On libre le champs points 
		free(poly); //Puis la structure
	}
}

void afficher_polygone(t_polygone* poly)
{
	int i; 

	if (poly == NULL) //On s'assure que le polygone est valide
	{
		printf("ERREUR: Polygone invalide.");
		return;
	}
	
	printf("Nombre de points: %d\n", poly->nb_points);

	//On affiche chacun des points, un par ligne.
	for (i = 0; i < poly->nb_points; i++)
	{
		afficher_point(poly->points[i]);
	}
}

//Sauvegarde un polygone dans un fichier texte
int sauvegarder_polygone(t_polygone* poly, char* nom_fichier)
{
	FILE* fichier; //Rfrence vers le fichier  crer.
	int i;

	//On ouvre le fichier et on s'assure que a a t ouvert correctement.
	fichier = fopen(nom_fichier, "w");
	if (!fichier) { //Rappel: quivalent  (fichier!=NULL) car NULL est une constante qui vaut 0
		return 0; //On retourne FAUX
	}

	//On crit le nombre de points sur la premire ligne
	fprintf(fichier, "%d\n", poly->nb_points);

	//On crit les points, un point par ligne
	for (i = 0; i < poly->nb_points; i++) {
		fprintf(fichier, "%lf %lf\n", poly->points[i].x, poly->points[i].y);
	}

	//On n'oublie pas de fermer le fichier.
	fclose(fichier);

	return 1;
}

//Charge un polygone depuis le disque
t_polygone* charger_polygone(char* nom_fich)
{
	FILE* fichier; //Rfrence vers le fichier  crer.
	t_polygone *poly; //Le polygone cr contenant les informations lues dans le fichier
	int nb_points; //Le nombre de points lu dans le fichier.
	int i;

	//On ouvre le fichier et on s'assure que a a t ouvert correctement.
	fichier = fopen(nom_fich, "r");
	if (!fichier) { //Rappel: quivalent  (fichier!=NULL) car NULL est une constante qui vaut 0
		return NULL; //On retourne FAUX
	}

	//On lit le nombre de points
	fscanf(fichier, "%d", &nb_points);

	//On alloue un polygone avec le nombre de points qu'on a lu dans le fichier
	poly = init_polygone(nb_points);
	if (poly == NULL) {
		return NULL;
	}

	//On lit les points un  un, qu'on stocke dans le polygone nouvellement cr
	for (i = 0; i < nb_points; i++) {
		fscanf(fichier, "%lf", &poly->points[i].x);
		fscanf(fichier, "%lf", &poly->points[i].y);
		//NDE: On peut combiner les deux fscanf en un seul: 
		//fscanf(fichier, "%lf %lf", &poly->points->x, &poly->points->y);
	}

	//On a termin de lire tous les points, on ferme le fichier.
	fclose(fichier);

	return poly;

}