/*
MODULE Q5_T_POLYGONE

Dfinit le type t_polygone et son constructeur, destructeur et les fonctions pour la sauvegarde et 
le chargement d'un polygone depuis un fichier texte.
*/

#ifndef Q5_T_POLYGONE_H_
#define Q5_T_POLYGONE_H_

#include "q5_t_point.h"
#include <stdio.h>
#include <assert.h>

typedef struct {
	int nb_points;   // Nombre de points du polygone
	t_point *points; //Tableau dynamique de points
} t_polygone;


/*
INIT_POLYGONE
Constructeur d'un polygone. Le polygone est allou dynamiquement ainsi que le 
tableau de points, selon le nombre de points demands en paramtre.

NDE : Cette fonction est ajoute ici par commodit (pas demande dans l'exercice).
      Elle est toutefois trs utile pour faire les tests.

Paramtres: 
nb_points (entier): Nombre de points pour le nouveau polygone  crer.
Retour: L'adresse du polygone nouvellement cr, NULL si une erreur s'est produite.
*/
t_polygone* init_polygone(int nb_points);


/*
DETRUIRE_POLYGONE
Destructeur d'un polygone allou dynamiquement. 

NDE : Cette fonction est ajoute ici par commodit (pas demande dans l'exercice).
	  Elle est toutefois trs utile pour faire les tests.

Paramtres:
poly (t_polygone): Le polygone  dtruire.
Retour: Aucun.
*/
void detruire_polygone(t_polygone* poly);

/*
AFFICHER_POLYGONE
Fonction utilitaire qui affiche un polygone dans la console (son nombre de points
et les coordonnes de chacun de ses points).

NDE : Cette fonction est ajoute ici par commodit (pas demande dans l'exercice).

Paramtres:
- poly (t_polygone): Le polygone  afficher.
Retour: Aucun.
*/
void afficher_polygone(t_polygone* poly);

/*
SAUVEGARDER_POLYGONE
Sauvegarde un polygone dans un fichier texte. 

Paramtres: 
- poly (t_polygone): Le polygone  sauvegarder
- nom_fichier (chaine de caractres): Le nom du fichier  crer et o les donnes du polygone
  seront sauvegardes.
Retour (entier): Vrai si la sauvegarde s'est bien droule, Faux sinon.
*/

/*
CHARGER_POLYGONE
Charge les informations d'un polygone depuis un fichier texte et retourne
un polygone dynamiquement allou comportant les informations lues.

NOTE: On suppose que le fichier a le bon formatet aucune vrification n'est 
faite dans la fonction pour le valider.

Paramtres:
- nom_fichier (chaine de caractres): Le nom du fichier  lire.
Retour (t_polygone*): Refrence vers le polygone cr, ou NULL si une erreur s'est produite.
*/
t_polygone* charger_polygone(char* nom_fich);

#endif